import aima.core.search.framework.DefaultGoalTest;
import aima.core.search.framework.Problem;
import aima.core.search.framework.Search;
import aima.core.search.framework.TreeSearch;
import aima.core.search.framework.GraphSearch;
import aima.core.search.framework.GraphSearch;
import aima.core.search.informed.AStarSearch;
import aima.core.search.framework.SearchAgent;

import java.util.List;
import java.util.Iterator;
import aima.core.agent.Action;

public class MapAStarTest {

	public static void doAtest() {
		try {
			System.out.println("Flashlight test");

			Map romaniaMap = new SimplifiedRoadMapOfPartOfRomania();

			Problem problem = new Problem(
				SimplifiedRoadMapOfPartOfRomania.ARAD,
				MapFunctionFactory.getActionsFunction(romaniaMap),
				MapFunctionFactory.getResultFunction(), 
				new DefaultGoalTest( SimplifiedRoadMapOfPartOfRomania.BUCHAREST),
				new MapStepCostFunction(romaniaMap)
				);
			Search search = new AStarSearch(
				new GraphSearch(),
				new StraightLineDistanceHeuristicFunction(SimplifiedRoadMapOfPartOfRomania.BUCHAREST, romaniaMap)
				);
			SearchAgent agent = new SearchAgent(problem, search);

			System.out.println( agent.getActions().toString()) ;
			System.out.println(agent.getInstrumentation().getProperty("nodesExpanded") + " nodes Expanded");
			System.out.println(agent.getInstrumentation().getProperty("queueSize") + " queue size");
			System.out.println(agent.getInstrumentation().getProperty("maxQueueSize") + " max queue size");
		} catch (Exception e) {
			e.printStackTrace();
		}
			
	}
	public static void main(String[] args) {
		doAtest();
	}
}
